## pasdoc 0.13.0

=== Makefile ===
include Makefile-autodetect

#######################################################################
# BASE CONFIGURATION
#######################################################################

# The version of the package.
# This must be changed on each version change,
# documented at ReleaseMaking wiki page.
VERSION := 0.13.0

# The name of the package / file name
PACKAGENAME := pasdoc

# Location of units source code.
UNIT_DIRS := ./source/component ./source/console \
  ./source/component/tipue

INCLUDE_DIRS := ./source/component ./source/component/images

# Base file to compile
FILE := ./source/console/pasdoc.dpr

# Base directory where binaries will go
BINDIR := bin

# Base directory where libs, units, objects files will go
OUTDIR := lib

# The following is for creating the final package, comment out
# if that particular section is not used.
# BINFILES: Files that will go into the resulting bin directory
# DOCFILES: Files that will go into the resulting docs directory
BINFILES := $(BINDIR)/pasdoc
DOCFILES := LICENSE ChangeLog docs/README

PACKAGE_BASENAME := $(PACKAGENAME)-$(VERSION)-$(PACKAGE_BASENAME_SUFFIX)

############################################################################
# Variables below are *not* configurable, i.e. don't change them (unless
# you know what you're doing and you're able to accordingly change
# some rules later in this Makefile, that may depend on given variable's
# value).
############################################################################

PACKAGEDIR := $(PACKAGEBASEDIR)$(PATHSEP)$(PACKAGENAME)

############################################################################
# Change the paths to the correct types
#######################################################################

ifdef OUTDIR
OUTDIR := $(subst /,$(PATHSEP),$(OUTDIR))
endif
ifdef BINDIR
BINDIR := $(subst /,$(PATHSEP),$(BINDIR))
endif
FILE := $(subst /,$(PATHSEP),$(FILE))
UNIT_DIRS := $(subst /,$(PATHSEP),$(UNIT_DIRS))
INCLUDE_DIRS := $(subst /,$(PATHSEP),$(INCLUDE_DIRS))
ifdef BINFILES
BINFILES := $(subst /,$(PATHSEP),$(BINFILES))
endif
ifdef DOCFILES
DOCFILES := $(subst /,$(PATHSEP),$(DOCFILES))
endif

############################################################################
# FreePascal Configuration
############################################################################

# FPC_DEFAULT means "use current os and processor",
# calling just fpc binary on the path
FPC_DEFAULT := fpc

# By default all of below variables are set to $(FPC_DEFAULT), because
# $(FPC_DEFAULT) is the only good default value that can possibly work
# for everyone. You can override them at `make' command-line,
# e.g. if you have different FPC versions and you use them to do cross-compiling.
FPC_WIN32 := $(FPC_DEFAULT)
FPC_GO32 := $(FPC_DEFAULT)
FPC_LINUX_X86 := $(FPC_DEFAULT)
FPC_LINUX_X86_64 := $(FPC_DEFAULT)
FPC_LINUX_M68K := $(FPC_DEFAULT)
FPC_LINUX_PPC := $(FPC_DEFAULT)
FPC_AMIGA := $(FPC_DEFAULT)
FPC_BEOS := $(FPC_DEFAULT)
FPC_OS2 := $(FPC_DEFAULT)
FPC_FREEBSD_X86 := $(FPC_DEFAULT)
FPC_DARWIN_X86 := $(FPC_DEFAULT)

FPC_UNIT_DIRS := $(foreach units,$(UNIT_DIRS),-Fu$(units))
FPC_INCLUDE_DIRS := $(foreach units,$(INCLUDE_DIRS),-Fi$(units))

FPC_COMMON_FLAGS := -FE$(BINDIR) -FU$(OUTDIR) @pasdoc-fpc.cfg \
  $(FPC_UNIT_DIRS) $(FPC_INCLUDE_DIRS)

FPC_DEBUG_FLAGS := $(FPC_COMMON_FLAGS)

FPC_RELEASE_FLAGS := -dRELEASE $(FPC_COMMON_FLAGS)

############################################################################
# Delphi configuration
############################################################################

# Don't ask me why, but Borland named Delphi/Win32 command-line compiler
# dcc32 and Delphi/Linux (aka Kylix) as dcc (without 32).

DCC_WIN32 := dcc32
DCC_LINUX := dcc
DCC_UNIT_DIRS := $(foreach units,$(UNIT_DIRS),-U$(units))
DCC_INCLUDE_DIRS := $(foreach units,$(INCLUDE_DIRS),-I$(units))

# Command-line dcc prints non-errorlines while it works,
# I guess that it was meant to somehow indicate
# compilation progress, although it's rather confusing and hides
# meaningfull error/warning lines. That's why we pass -Q below.

DCC_COMMON_FLAGS := -E$(BINDIR) -N$(OUTDIR) -L$(OUTDIR) -M -H -W -Q \
  -DCPU86 -DENDIAN_LITTLE $(DCC_UNIT_DIRS) $(DCC_INCLUDE_DIRS)

DCC_DEBUG_FLAGS := -$$Q+ -$$R+ $(DCC_COMMON_FLAGS)

DCC_RELEASE_FLAGS := -$$O+ $(DCC_COMMON_FLAGS)

############################################################################
# Virtual Pascal configuration
############################################################################

# TODO: check this, either remove (if vpc does not work anymore),
# or add to CompilingPasDoc as supported compiler,
# remove hardcoded paths to vpc installation.

VPC := F:\vp21\bin.w32\vpc.exe
VPCRTLWIN32UNITDIR := F:\vp21\units.w32
VPCRTLWIN32LIBDIR := -LF:\vp21\units.w32 -LF:\vp21\lib.w32
VPCRTLOS2UNITDIR := F:\vp21\units.os2
VPCRTLOS2LIBDIR := -LF:\vp21\units.os2 -LF:\vp21\lib.os2
VPCUNITDIRS := $(foreach units,$(UNIT_DIRS),-U$(units))
VPCINCDIRS := $(foreach units,$(INCLUDE_DIRS),-I$(units))
VPCFLAGS := -E$(BINDIR) -M -$$J+ -$$R+ -DCPU86 -DENDIAN_LITTLE -O$(OUTDIR) \
  $(VPCINCDIRS) -L$(OUTDIR)

############################################################################
# Building (and cleaning after building)
############################################################################

.PHONY: default clean build-fpc-default-debug build-fpc-default \
  build-fpc-win32 build-fpc-go32 \
  build-fpc-linux-x86 build-fpc-linux-m68k build-fpc-linux-x86_64 \
  build-fpc-amiga build-fpc-beos \
  build-fpc-os2 build-fpc-linux-ppc build-fpc-freebsd-x86 \
  build-fpc-darwin-x86 \
  build-delphi-win32 build-delphi-linux-x86 \
  build-vpc-win32 build-vpc-os2 make-dirs

# Default target
default: build-fpc-default-debug

# Clean up the output files.
clean:
	rm -Rf source/console/pasdoc.compiled \
	       source/packages/lazarus/lib/ \
	       source/gui/pasdoc_gui.compiled \
	       source/gui/pasdoc_gui \
	       source/gui/pasdoc_gui.exe \
	       source/gui/pasdoc_gui.app \
	       source/gui/*.o \
	       source/gui/*.or \
	       source/gui/*.ppu \
	       source/gui/*.res

ifdef OUTDIR
	rm -Rf $(OUTDIR)
endif
ifdef BINDIR
	rm -Rf $(BINDIR)
endif

# Make sure that $(BINDIR) and $(OUTDIR) exist, create them if necessary.
# This is executed before executing any `build-xxx' target,
# to make sure that compilation works "out of the box".
#
# Always using special directories for $(BINDIR) and $(OUTDIR) is handy
# -- reduces clutter, allows us to easily write `clean' target.
#
# Note that, unless you override $(BINDIR) and $(OUTDIR) at command-line,
# they don't really help you when you have various compilers, for
# various os/arch etc. because $(BINDIR) and $(OUTDIR) are always the same
# anyway, so all compilers reuse the same dirs... In the future various
# build-<compiler>-<os/arch> targets may be tweaked to use different
# $(BINDIR) and $(OUTDIR).
make-dirs:
ifdef OUTDIR
	$(MKDIRPROG) -p $(OUTDIR)
endif
ifdef BINDIR
	$(MKDIRPROG) -p $(BINDIR)
endif

# fpc- build targets

build-fpc-default-debug: make-dirs
	$(FPC_DEFAULT) $(FPC_DEBUG_FLAGS) $(FILE)

build-fpc-default: make-dirs
	$(FPC_DEFAULT) $(FPC_RELEASE_FLAGS) $(FILE)

build-fpc-win32: make-dirs
	$(FPC_WIN32) $(FPC_RELEASE_FLAGS) $(FILE)

build-fpc-go32: make-dirs
	$(FPC_GO32) $(FPC_RELEASE_FLAGS) $(FILE)

build-fpc-linux-x86: make-dirs
	$(FPC_LINUX_X86) $(FPC_RELEASE_FLAGS) $(FILE)

build-fpc-linux-x86_64: make-dirs
	$(FPC_LINUX_X86_64) $(FPC_RELEASE_FLAGS) $(FILE)

build-fpc-linux-m68k: make-dirs
	$(FPC_LINUX_M68K) $(FPC_RELEASE_FLAGS) $(FILE)

build-fpc-amiga: make-dirs
	$(FPC_AMIGA) $(FPC_RELEASE_FLAGS) $(FILE)

build-fpc-beos: make-dirs
	$(FPC_BEOS) $(FPC_RELEASE_FLAGS) $(FILE)

build-fpc-os2: make-dirs
	$(FPC_OS2) $(FPC_RELEASE_FLAGS) $(FILE)

build-fpc-linux-ppc: make-dirs
	$(FPC_LINUX_PPC) $(FPC_RELEASE_FLAGS) $(FILE)

build-fpc-freebsd-x86: make-dirs
	$(FPC_FREEBSD_X86) $(FPC_RELEASE_FLAGS) $(FILE)

build-fpc-darwin-x86: make-dirs
	$(FPC_DARWIN_X86) $(FPC_RELEASE_FLAGS) $(FILE)

# Delphi/Kylix build targets

# Implementation note: this $(subst...) is needed, otherwise under Windows
# dcc dumbly prints "file not found" when $(FILE) uses "/" (yes, "/" is allowed
# path separator in all normal Windows programs...) (and $(FILE) uses
# "/" because this is sensible default value for $(PATHSEP), otherwise we would
# have to do dirty checks to guess whether we're used under Unix or Win32 in
# this Makefile).
build-delphi-win32: make-dirs
	$(DCC_WIN32) $(DCC_RELEASE_FLAGS) $(subst $(PATHSEP),\\,$(FILE))

build-delphi-linux-x86: make-dirs
	$(DCC_LINUX) $(DCC_RELEASE_FLAGS) $(FILE)

# vpc build targets

build-vpc-win32: make-dirs
	$(VPC) -CW $(VPCFLAGS)  $(VPCRTLWIN32LIBDIR) -U$(VPCRTLWIN32UNITDIR) $(VPCUNITDIRS) $(FILE)

build-vpc-os2: make-dirs
	$(VPC) -CO $(VPCFLAGS)  $(VPCRTLOS2LIBDIR) -U$(VPCRTLOS2UNITDIR) $(VPCUNITDIRS) $(FILE)

build-pascal_pre_proc: make-dirs
	$(FPC_DEFAULT) $(FPC_DEBUG_FLAGS) ./source/tools/pascal_pre_proc.dpr

############################################################################
# Help targets
############################################################################

.PHONY: help

help:
	@echo "Available targets of this Makefile:"
	@echo
	@echo "Compiling:"
	@echo
	@echo "  default, build-fpc-default-debug:"
	@echo "    Compile debug version with FPC. This is the default target."
	@echo
	@echo "  build-fpc-default:"
	@echo "    Compile release version with FPC."
	@echo
	@echo "  build-<compiler>-<os/arch>:"
	@echo "    Compile release version with given compiler for given OS"
	@echo "    and architecture. Available values for <compiler> are:"
	@echo "      fpc"
	@echo "      delphi"
	@echo "      vpc"
	@echo "    Available values for <os/arch> are:"
	@echo "      win32"
	@echo "      go32"
	@echo "      linux-x86"
	@echo "      linux-x86_64"
	@echo "      linux-m68k"
	@echo "      amiga"
	@echo "      beos"
	@echo "      os2"
	@echo "      linux-ppc"
	@echo "      freebsd-x86"
	@echo "      darwin-x86"
	@echo "    Of course, not all combinations of <compiler> and <os/arch>"
	@echo "    are available..."
	@echo
	@echo "    Note that in case of FPC, these targets assume that variable"
	@echo "    FPC_<os/arch> points to a compiler that produces"
	@echo "    a binary for given <os/arch>. So if you want to cross-compile"
	@echo "    with FPC, make sure to adjust these variables accordingly."
	@echo
	@echo "  clean:"
	@echo "    Clean files produced during compilation."
	@echo
	@echo "Archiving a release:"
	@echo
	@echo "  dist-<os/arch>:"
	@echo "    This calls \"clean\", then \"build-<compiler>-<os/arch>\""
	@echo "    (using the preferred <compiler> for making a release on"
	@echo "    this <os/arch> -- currently, always FPC)"
	@echo "    and then makes a release archive for given <os/arch>."
	@echo
	@echo "  dist-src:"
	@echo "    This creates source archive, by exporting whole pasdoc sources"
	@echo "    from pasdoc SVN. It exports using the tag name taken from"
	@echo "    VERSION variable in this Makefile (currently it's "$(VERSION)")."

.PHONY: version
version:
	@echo $(VERSION)

############################################################################
# Targets to make release archives
#
# Some general targets are present here, and targets
# that build and archive for particular platform.
# Note that each dist-<os/arch> target assumes that according build-fpc-<os/arch>
# target produces a pasdoc binary that works under <os/arch> platform.
# So if you want to cross-compile to create release archives,
# make sure that variables FPC_<os/arch> are properly set.
#
# Note that dist targets use the most common archive format for given platform.
# E.g. for Unices this is tar.gz, for Win32/DOS this is zip.
# There would be no problems with creating zip archives under Unices
# (or tar.gz under Win32/DOS), but it's just more common
# to use tar.gz under Unices.
############################################################################

=== source/component/tipue/Makefile ===
# Generates all *.inc files from text/binary files in this directory.

ALL_OUTPUT := tipuesearch.css.inc tipuesearch.js.inc tipuesearch_set.js.inc _tipue_results.html.inc search.gif.inc jquery-1.7.1.min.js.inc

.PHONY: all clean

all: $(ALL_OUTPUT)

search.gif.inc: search.gif
	../../tools/file_to_pascal_data $< $@

%.inc: %
	../../tools/file_to_pascal_string $< $@

clean:
	rm -f $(ALL_OUTPUT)

=== debian/changelog ===
pasdoc (0.13.0-1) unstable; urgency=medium

  * Initial release. (Closes: #747547)

 -- Paul Gevers <elbrus@debian.org>  Sat, 17 May 2014 12:26:42 +0200

=== debian/control ===
Source: pasdoc
Section: doc
Priority: optional
Maintainer: Pascal Packaging Team <pkg-pascal-devel@lists.alioth.debian.org>
Uploaders: Paul Gevers <elbrus@debian.org>
Build-Depends: debhelper (>= 9),
 fp-compiler,
 fp-units-fcl,
 help2man,
 latex2html,
 libxml2-utils,
 opensp,
 texlive-latex-base
Standards-Version: 3.9.5
Homepage: http://pasdoc.sipsolutions.net/
Vcs-browser: http://anonscm.debian.org/gitweb/?p=pkg-pascal/pasdoc.git
Vcs-git: git://anonscm.debian.org/pkg-pascal/pasdoc.git

Package: pasdoc
Architecture: any
Depends: ${misc:Depends},
Description: documentation tool for Pascal source code
 Pasdoc generates documentation for Pascal units. It takes descriptions from
 comments within the source code. Documentation output formats include HTML and
 LaTeX. Object Pascal, FreePascal and Delphi specific features are supported.
 .
 Pasdoc has the follow features:
  * Understands code written in any Pascal and Object Pascal dialect
  * Understands modern Object Pascal language, as found in latest FreePascal
    and Delphi versions
  * Many output formats: HTML, HTMLHelp, LaTeX (PDF, PS), latex2rft, XML
  * Command-line (in batch mode) and GUI interface
  * Documentation from comments in the source code and/or provided in separate
    file
  * Arbitrary (even optional) comment markers
  * Special @-tags for formatting the documentation
  * Whole pages (like introduction to the docs) can be written using @-tags
  * Easy search box in HTML output using Tipue
  * Classes and unit dependency graphs
  * Optional automatic linking of identifiers
  * Spell checking
  * Cache for generating documentation fast

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# the newly created binary is needed for the test-suite, so put it on the path
# I actually only want to do this while running the test-suite, but I can't
# figure out how to do that in a Makefile
export PATH:=${PATH}:$(shell pwd)/bin

%:
	dh ${@}

override_dh_auto_clean:
	dh_auto_clean
	make -C tests clean
	make -C docs clean

override_dh_auto_build:
	# Build the documentation (upstream has no make targets for this)
	pdflatex --output-directory docs docs/pasdoc.tex
	latex2html -split 0 -dir docs docs/pasdoc.tex

	dh_auto_build
	# Use the help from the binary to create a man page as none is supplied.
	help2man --output=pasdoc.1 --name="documentation tool for Pascal source code" \
		 bin/pasdoc

override_dh_auto_test:
	# There are more tests possible and the latex versions are not really
	# checked yet as the non validate_ tests will not fail.
	# Also disable validate_html for now as it takes extremely long and needs a
	# working network connection. Have to figure out how to fix that.
	make -C tests html htmlhelp simplexml latex latex2rtf validate_simplexml #validate_html

## pasdoc 0.14.0

=== Makefile ===
--- 
+++ 
@@ -7,7 +7,7 @@
 # The version of the package.
 # This must be changed on each version change,
 # documented at ReleaseMaking wiki page.
-VERSION := 0.13.0
+VERSION := 0.14.0
 
 # The name of the package / file name
 PACKAGENAME := pasdoc
@@ -22,10 +22,14 @@
 FILE := ./source/console/pasdoc.dpr
 
 # Base directory where binaries will go
+ifndef BINDIR
 BINDIR := bin
+endif
 
 # Base directory where libs, units, objects files will go
+ifndef OUTDIR
 OUTDIR := lib
+endif
 
 # The following is for creating the final package, comment out
 # if that particular section is not used.
@@ -263,6 +267,11 @@
 
 build-pascal_pre_proc: make-dirs
 	$(FPC_DEFAULT) $(FPC_DEBUG_FLAGS) ./source/tools/pascal_pre_proc.dpr
+
+build-gui:
+	lazbuild $(LAZBUILD_OPTIONS) source/packages/lazarus/pasdoc_package.lpk
+	lazbuild $(LAZBUILD_OPTIONS) source/gui/pasdoc_gui.lpi
+	strip source/gui/pasdoc_gui$(EXE)
 
 ############################################################################
 # Help targets
@@ -307,6 +316,9 @@
 	@echo "    a binary for given <os/arch>. So if you want to cross-compile"
 	@echo "    with FPC, make sure to adjust these variables accordingly."
 	@echo
+	@echo "  build-gui:"
+	@echo "    Compile pasdoc_gui with lazbuild (Lazarus build tool)."
+	@echo
 	@echo "  clean:"
 	@echo "    Clean files produced during compilation."
 	@echo
@@ -338,9 +350,3 @@
 # make sure that variables FPC_<os/arch> are properly set.
 #
 # Note that dist targets use the most common archive format for given platform.
-# E.g. for Unices this is tar.gz, for Win32/DOS this is zip.
-# There would be no problems with creating zip archives under Unices
-# (or tar.gz under Win32/DOS), but it's just more common
-# to use tar.gz under Unices.
-############################################################################
-

=== tests/Makefile ===
# See README for docs how to use this Makefile.

# Making docs ----------------------------------------

.PHONY: html pdf latex dvi htmlhelp simplexml

html:
	scripts/mk_tests.sh html

dvi: latex/docs.dvi

pdf: latex/docs.pdf

latex: latex/docs.tex

latex2rtf: latex2rtf/docs.tex

htmlhelp:
	scripts/mk_tests.sh htmlhelp

simplexml:
	scripts/mk_tests.sh simplexml

latex/docs.tex:
	scripts/mk_tests.sh latex

# (Yes, I must do `cd latex' before calling pdflatex, I can't simply call
# `pdflatex latex/docs.tex' because then many output files of pdflatex
# would be placed in current dir)
latex/docs.pdf: latex/docs.tex
	cd latex; pdflatex --file-line-error-style -interaction=nonstopmode docs.tex
	cd latex; pdflatex --file-line-error-style -interaction=nonstopmode docs.tex

latex/docs.dvi: latex/docs.tex
	cd latex; latex --file-line-error-style -interaction=nonstopmode docs.tex
	cd latex; latex --file-line-error-style -interaction=nonstopmode docs.tex

latex2rtf/docs.tex:
	scripts/mk_tests.sh latex2rtf

# Other targets ----------------------------------------

validate_html:
	scripts/validate_html.sh

validate_simplexml:
	scripts/validate_simplexml.sh

clean:
	rm -Rf html/ latex/ htmlhelp/ latex2rtf/ simplexml/ \
	  scripts/check_cache_tmp/ \
	  scripts/upload_correct_tests_output_tmp/

# eof ----------------------------------------

=== source/autodoc/Makefile ===
# This Makefile creates PasDoc generated documentation for PasDoc itself.
# Documentation is created in subdirectories named after pasdoc's --format
# names (html/, latex/ etc.)
#
# Targets:
#
#   html latex pdf dvi ps html-latex htmlhelp rtf
#     Make documentation in requested format.
#
#   clean
#     Delete all generated documentation.
#
#   public
#     Generate documentation in all formats that we want to show
#     on http://pasdoc.sourceforge.net/autodoc/.
#
#   upload
#     Upload documentation generated by `public'
#     to http://pasdoc.sourceforge.net/autodoc/.
#     Of course you need to have sourceforge account and sufficient privileges
#     on sourceforge web server to do this (you need to be a pasdoc developer).
#     It uses scp program. You will be asked for password (more than once)
#     unless you configured ssh keys for your sourceforge account,
#     so configuring ssh keys is really advised.
#     You should override SF_USERNAME variable at command-line to your
#     username on sourceforge.
#
#     Note that scp displays progress meter on output, if you don't want this
#     (e.g. because you run "make" into Emacs compilation buffer)
#     you can pass option `-q' to scp, calling make like this
#     `make upload SCP_OPTIONS=-q SF_USERNAME=my_user_name'
#
#     For the sake of other pasdoc developers that would like
#     to also be able to execute `make upload' to upload freshest
#     version of autodoc, this target makes sure the uploaded files
#     are writeable by the group `pasdoc', so other pasdoc developers
#     may override them.
#
# Some hints:
#   To completely remake all documentation for
#   http://pasdoc.sourceforge.net/autodoc/
#   just call `make clean public upload SF_USERNAME=my_user_name'

# Making documentation ----------------------------------------

# Name of pasdoc binary. Remember that you can override it at
# make's command-line, like `make PASDOC=my_pasdoc'
PASDOC=pasdoc

# These options will be passed to every pasdoc invocation,
# i.e. for every output format.
PASDOC_OPTIONS=--include ../component \
  ../component/*.pas ../component/tipue/*.pas \
  ../console/*.pas \
  -DFPC -DVER2 \
  --title "PasDoc's autodoc" --write-uses-list  --auto-abstract \
  --introduction=introduction.txt

GRAPHVIZ_COMMANDS=dot -Grankdir=LR -Tjpg -oGVClasses.jpg GVClasses.dot; \
                  dot -Grankdir=LR -Tjpg -oGVUses.jpg GVUses.dot

# These options will be passed only when making docs in format that
# supports including graphviz graphs.
PASDOC_GRAPHVIZ_OPTIONS=--graphviz-classes --graphviz-uses \
  --link-gv-classes jpg --link-gv-uses jpg

# How to call hhc (html help compiler) ?
# Default value means that it must be available on path.
# As usual, remember you can override it at make's command-line.
HHC=hhc

.PHONY: html latex pdf dvi ps html-latex clean htmlhelp rtf

html:
	mkdir -p html/
	$(PASDOC) $(PASDOC_OPTIONS) $(PASDOC_GRAPHVIZ_OPTIONS) \
	  --output=html/ --use-tipue-search
	cd html/; $(GRAPHVIZ_COMMANDS)

# Ignore exit code from hhc (it's always 1 ???)
htmlhelp:
	mkdir -p htmlhelp/
	$(PASDOC) $(PASDOC_OPTIONS) $(PASDOC_GRAPHVIZ_OPTIONS) \
	  --format=htmlhelp --output=htmlhelp/
	cd htmlhelp/; $(GRAPHVIZ_COMMANDS)
	-cd htmlhelp/; $(HHC) docs.hhp

# Just shortcuts
latex: latex/docs.tex
pdf: latex/docs.pdf
dvi: latex/docs.dvi
ps: latex/docs.ps
html-latex: latex/docs.html
rtf: latex2rtf/docs.rtf

latex/docs.tex:
	mkdir -p latex/
	$(PASDOC) $(PASDOC_OPTIONS) \
	  --format=latex --output=latex/

# (Yes, I must do `cd latex' before calling pdflatex, I can't simply call
# `pdflatex latex/docs.tex' because then many output files of pdflatex
# would be placed in current dir)
latex/docs.pdf: latex/docs.tex
	cd latex; pdflatex --file-line-error-style -interaction=nonstopmode docs.tex
	cd latex; pdflatex --file-line-error-style -interaction=nonstopmode docs.tex

latex/docs.dvi: latex/docs.tex
	cd latex; latex --file-line-error-style -interaction=nonstopmode docs.tex
	cd latex; latex --file-line-error-style -interaction=nonstopmode docs.tex

latex/docs.ps: latex/docs.dvi
	cd latex; dvips docs.dvi -o docs.ps

# When working htlatex overrides latex/docs.dvi with a version
# that is not really a useful to browse (it's only for htlatex internals).
# That's why I `rm' it afterwards.
#
# As far as I understand how htlatex works, it's not needed to run
# htlatex twice (like it's needed with pdflatex and latex).
latex/docs.html: latex/docs.tex
	cd latex; htlatex docs.tex
	rm latex/docs.dvi

latex2rtf/docs.tex:
	mkdir -p latex2rtf/
	$(PASDOC) $(PASDOC_OPTIONS) \
	  --format=latex2rtf --output=latex2rtf/

# I must have latex/docs.tex as a prerequisite, to run latex over it
# to generate docs.aux file. Then I can use latex/docs.aux file with latex2rtf
# so that latex2rtf can make appropriate links.
latex2rtf/docs.rtf: latex2rtf/docs.tex latex/docs.tex
	cd latex/; latex --file-line-error-style -interaction=nonstopmode docs.tex
	cd latex2rtf/; latex2rtf -a ../latex/docs.aux docs.tex

clean:
	rm -Rf html/ latex/ latex2rtf/ htmlhelp/

# ------------------------------------------------------------
# Making and uploading autodoc for http://pasdoc.sourceforge.net/autodoc/

# html-latex format output used to be included here too,
# but honestly htlatex is too bad to show publicly.
# Besides htlatex is broken on my system right now :)
# If you want to restore html-latex for public autodoc demo,
# add to the upload target
#	scp $(SCP_OPTIONS) latex/docs.html $(SF_CONNECT)latex/
#	scp $(SCP_OPTIONS) latex/docs.css $(SF_CONNECT)latex/

.PHONY:	public upload

public: html pdf latex

# Override this at command-line to your username,
# like `make upload SF_USERNAME=my_user_name'
SF_USERNAME=kambi

SF_HOST=web.sourceforge.net
SF_PATH=/home/project-web/pasdoc/htdocs/autodoc/

SF_CONNECT=$(SF_USERNAME),pasdoc@$(SF_HOST):$(SF_PATH)

SCP_OPTIONS=

upload:
	scp $(SCP_OPTIONS) -r html/ $(SF_CONNECT)
	scp $(SCP_OPTIONS) latex/docs.pdf $(SF_CONNECT)latex/
	scp $(SCP_OPTIONS) latex/docs.tex $(SF_CONNECT)latex/
# Not required anymore: with new SF shell, I'm logging in with ",pasdoc"
# in username, so the files will already be owned by "pasdoc" group by default.
#	../../tests/scripts/ssh_chmod_writeable_by_pasdoc.sh \
#	  $(SF_USERNAME),pasdoc $(SF_PATH)

# eof ------------------------------------------------------------

=== source/component/Makefile ===
# Generates all *.inc files from text/binary files in this directory.

ALL_OUTPUT := pasdoc.css.inc external_class_hierarchy.txt.inc

.PHONY: all clean

all: $(ALL_OUTPUT)

%.inc: %
	../tools/file_to_pascal_string $< $@

clean:
	rm -f $(ALL_OUTPUT)

=== source/component/tipue/Makefile ===
# Generates all *.inc files from text/binary files in this directory.

ALL_OUTPUT := tipuesearch.css.inc tipuesearch.js.inc \
  tipuesearch_set.js.inc _tipue_results.html.inc \
  search.png.inc loader.gif.inc jquery.min.js.inc

.PHONY: all clean

all: $(ALL_OUTPUT)

_tipue_results.html.inc: _tipue_results.html
	../../tools/file_to_pascal_string $< $@

# We use file_to_pascal_data even for text files, to workaround
# Delphi problems with long strings, see
# https://sourceforge.net/p/pasdoc/bugs/82/

%.inc: %
	../../tools/file_to_pascal_data $< $@

clean:
	rm -f $(ALL_OUTPUT)

=== debian/changelog ===
pasdoc (0.14.0-1) unstable; urgency=medium

  * New upstream release (the reproducicble build release)
  * Update copyright information
  * Bump standards-version (no changes)
  * Drop obsolete patch (applied upstream)
  * Drop debian/missing-sources as it is now upstream

 -- Paul Gevers <elbrus@debian.org>  Sun, 09 Aug 2015 20:07:06 +0200

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
  libxml2-utils,
  opensp,
  texlive-latex-base
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Homepage: http://pasdoc.sipsolutions.net/
 Vcs-browser: http://anonscm.debian.org/gitweb/?p=pkg-pascal/pasdoc.git
 Vcs-git: git://anonscm.debian.org/pkg-pascal/pasdoc.git

=== debian/rules ===
--- 
+++ 
@@ -25,7 +25,7 @@
 	dh_auto_build
 	# Use the help from the binary to create a man page as none is supplied.
 	help2man --output=pasdoc.1 --name="documentation tool for Pascal source code" \
-		 bin/pasdoc
+		 --no-info bin/pasdoc
 
 override_dh_auto_test:
 	# There are more tests possible and the latex versions are not really

=== debian/watch ===
version=3
# qa.debian.org runs a redirector which allows a simpler form of URL
# for SourceForge based projects. The format below will automatically
# be rewritten to use the redirector.
http://sf.net/pasdoc/pasdoc-(\d\S*)-src\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## pasdoc 0.15.0

=== Makefile ===
--- 
+++ 
@@ -6,8 +6,8 @@
 
 # The version of the package.
 # This must be changed on each version change,
-# documented at ReleaseMaking wiki page.
-VERSION := 0.14.0
+# as documented at https://github.com/pasdoc/pasdoc/wiki/ReleaseMaking .
+VERSION := 0.15.0
 
 # The name of the package / file name
 PACKAGENAME := pasdoc
@@ -35,8 +35,11 @@
 # if that particular section is not used.
 # BINFILES: Files that will go into the resulting bin directory
 # DOCFILES: Files that will go into the resulting docs directory
-BINFILES := $(BINDIR)/pasdoc
-DOCFILES := LICENSE ChangeLog docs/README
+BINFILES := $(BINDIR)/pasdoc$(EXE) \
+	$(BINDIR)/pascal_pre_proc$(EXE) \
+	$(BINDIR)/file_to_pascal_string$(EXE) \
+	$(BINDIR)/file_to_pascal_data$(EXE)
+DOCFILES := LICENSE ChangeLog README.md
 
 PACKAGE_BASENAME := $(PACKAGENAME)-$(VERSION)-$(PACKAGE_BASENAME_SUFFIX)
 
@@ -173,6 +176,8 @@
 	       source/gui/*.or \
 	       source/gui/*.ppu \
 	       source/gui/*.res
+	$(MAKE) clean -C tests/
+	$(MAKE) clean -C source/autodoc/
 
 ifdef OUTDIR
 	rm -Rf $(OUTDIR)
@@ -257,28 +262,37 @@
 build-delphi-linux-x86: make-dirs
 	$(DCC_LINUX) $(DCC_RELEASE_FLAGS) $(FILE)
 
-# vpc build targets
-
+# vpc build targets - obsolete, since vpc is no longer supported
 build-vpc-win32: make-dirs
 	$(VPC) -CW $(VPCFLAGS)  $(VPCRTLWIN32LIBDIR) -U$(VPCRTLWIN32UNITDIR) $(VPCUNITDIRS) $(FILE)
 
 build-vpc-os2: make-dirs
 	$(VPC) -CO $(VPCFLAGS)  $(VPCRTLOS2LIBDIR) -U$(VPCRTLOS2UNITDIR) $(VPCUNITDIRS) $(FILE)
 
+# obsolete target
 build-pascal_pre_proc: make-dirs
 	$(FPC_DEFAULT) $(FPC_DEBUG_FLAGS) ./source/tools/pascal_pre_proc.dpr
+
+build-tools: make-dirs
+	$(FPC_DEFAULT) $(FPC_DEBUG_FLAGS) ./source/tools/pascal_pre_proc.dpr
+	$(FPC_DEFAULT) $(FPC_DEBUG_FLAGS) ./source/tools/file_to_pascal_data.dpr
+	$(FPC_DEFAULT) $(FPC_DEBUG_FLAGS) ./source/tools/file_to_pascal_string.dpr
 
 build-gui:
 	lazbuild $(LAZBUILD_OPTIONS) source/packages/lazarus/pasdoc_package.lpk
 	lazbuild $(LAZBUILD_OPTIONS) source/gui/pasdoc_gui.lpi
 	strip source/gui/pasdoc_gui$(EXE)
 
+.PHONY: tests
+tests:
+	$(FPC_DEFAULT) $(FPC_DEBUG_FLAGS) ./tests/fpcunit/test_pasdoc.lpr
+	bin/test_pasdoc -a
+
 ############################################################################
 # Help targets
 ############################################################################
 
 .PHONY: help
-
 help:
 	@echo "Available targets of this Makefile:"
 	@echo
@@ -331,9 +345,7 @@
 	@echo "    and then makes a release archive for given <os/arch>."
 	@echo
 	@echo "  dist-src:"
-	@echo "    This creates source archive, by exporting whole pasdoc sources"
-	@echo "    from pasdoc SVN. It exports using the tag name taken from"
-	@echo "    VERSION variable in this Makefile (currently it's "$(VERSION)")."
+	@echo "    This creates source archive for the current sources."
 
 .PHONY: version
 version:
@@ -342,11 +354,3 @@
 ############################################################################
 # Targets to make release archives
 #
-# Some general targets are present here, and targets
-# that build and archive for particular platform.
-# Note that each dist-<os/arch> target assumes that according build-fpc-<os/arch>
-# target produces a pasdoc binary that works under <os/arch> platform.
-# So if you want to cross-compile to create release archives,
-# make sure that variables FPC_<os/arch> are properly set.
-#
-# Note that dist targets use the most common archive format for given platform.

=== tests/Makefile ===
.PHONY: clean
clean:
	rm -Rf current_output/ \
	  correct_output/ \
	  scripts/check_cache_tmp/ \
	  scripts/upload_correct_tests_output_tmp/

=== source/autodoc/Makefile ===
--- 
+++ 
@@ -135,7 +135,7 @@
 	cd latex2rtf/; latex2rtf -a ../latex/docs.aux docs.tex
 
 clean:
-	rm -Rf html/ latex/ latex2rtf/ htmlhelp/
+	rm -Rf html/ latex/ latex2rtf/ htmlhelp/ html_by_pasdoc_gui/
 
 # ------------------------------------------------------------
 # Making and uploading autodoc for http://pasdoc.sourceforge.net/autodoc/

=== source/component/Makefile ===
--- 
+++ 
@@ -7,7 +7,7 @@
 all: $(ALL_OUTPUT)
 
 %.inc: %
-	../tools/file_to_pascal_string $< $@
+	../../bin/file_to_pascal_string $< $@
 
 clean:
 	rm -f $(ALL_OUTPUT)

=== tests/fpcunit/Makefile ===
.PHONY: default
default:
	make -C ../../ tests

=== source/component/images/Makefile ===
# Generate all *.gif.inc files from *.gif files in this directory.
# Uses ../../tools/file_to_pascal_data program, so be sure that it's
# compiled.

ALL_OUTPUT := automated.gif.inc \
  private.gif.inc \
  protected.gif.inc \
  public.gif.inc \
  published.gif.inc

.PHONY: all clean

all: $(ALL_OUTPUT)

clean:
	rm -f $(ALL_OUTPUT)

%.gif.inc: %.gif
	../../tools/file_to_pascal_data $< $@

=== source/component/tipue/Makefile ===
--- 
+++ 
@@ -9,14 +9,14 @@
 all: $(ALL_OUTPUT)
 
 _tipue_results.html.inc: _tipue_results.html
-	../../tools/file_to_pascal_string $< $@
+	../../../bin/file_to_pascal_string $< $@
 
 # We use file_to_pascal_data even for text files, to workaround
 # Delphi problems with long strings, see
 # https://sourceforge.net/p/pasdoc/bugs/82/
 
 %.inc: %
-	../../tools/file_to_pascal_data $< $@
+	../../../bin/file_to_pascal_data $< $@
 
 clean:
 	rm -f $(ALL_OUTPUT)

=== source/packages/delphi/5.0/Makefile ===
pasdoc_package.dpk: ../7.0/pasdoc_package.dpk
	sed $< \
	  -e 's/{$$R \*.res}/{$$R *.RES} {$$ALIGN ON}/ig' \
	  -e 's/rtl,//ig' \
	  -e 's/vclx,/vclx50,/ig' \
	  -e 's/vcl;/vcl50;/ig' \
	  > $@

.PHONY: clean
clean:
	rm -f pasdoc_package.dpk

=== debian/changelog ===
pasdoc (0.15.0-2) unstable; urgency=medium

  * Use dh_install instead of dh_installman as help2man is broken (Closes:
    #954676)
  * Switch to compat 13 (via debhelper-compat B-D)
  * Bump standards to 4.5.0
  * Fix Vcs-Browser field
  * Add check for DEB_BUILD_OPTIONS in dh_auto_test override
  * Add R³: no

 -- Paul Gevers <elbrus@debian.org>  Mon, 20 Apr 2020 21:18:23 +0200

pasdoc (0.15.0-1) unstable; urgency=medium

  * New upstream release
    - CVE-2017-17527 Upstream removed the relevant code as it wasn't used
      anyways, see
      https://lists.alioth.debian.org/pipermail/pkg-pascal-devel/Week-of-Mon-20171211/002156.html
    - Adapt packaging in multiple ways to new source
  * Use system version of jquery during build (Closes: #858640)
  * Drop user documentation as upstream doesn't ship it anymore

 -- Paul Gevers <elbrus@debian.org>  Fri, 09 Feb 2018 22:42:15 +0100

=== debian/control ===
--- 
+++ 
@@ -3,18 +3,21 @@
 Priority: optional
 Maintainer: Pascal Packaging Team <pkg-pascal-devel@lists.alioth.debian.org>
 Uploaders: Paul Gevers <elbrus@debian.org>
-Build-Depends: debhelper (>= 9),
+Rules-Requires-Root: no
+Build-Depends: debhelper-compat (= 13),
  fp-compiler,
  fp-units-fcl,
+ graphviz,
  help2man,
  latex2html,
+ libjs-jquery,
  libxml2-utils,
  opensp,
  texlive-latex-base
-Standards-Version: 3.9.6
-Homepage: http://pasdoc.sipsolutions.net/
-Vcs-browser: http://anonscm.debian.org/gitweb/?p=pkg-pascal/pasdoc.git
-Vcs-git: git://anonscm.debian.org/pkg-pascal/pasdoc.git
+Standards-Version: 4.5.0
+Homepage: https://github.com/pasdoc/pasdoc/wiki
+Vcs-Browser: https://salsa.debian.org/pascal-team/pasdoc
+Vcs-Git: https://salsa.debian.org/pascal-team/pasdoc.git
 
 Package: pasdoc
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# the newly created binary is needed for the test-suite, so put it on the path
# I actually only want to do this while running the test-suite, but I can't
# figure out how to do that in a Makefile
export PATH:=${PATH}:$(shell pwd)/bin

%:
	dh ${@}

override_dh_auto_clean:
	dh_auto_clean
	make -C tests clean
	# I wish I could clean source/component here, but then the build-tools
	# target FTBFS, so clean in the override_dh_auto_build target instead.
#	make -C source/component clean
	make -C source/component/images clean
	make -C source/component/tipue clean

override_dh_auto_configure:
	ln -s /usr/share/javascript/jquery/jquery.js     source/component/tipue/
	ln -s /usr/share/javascript/jquery/jquery.min.js source/component/tipue/
	dh_auto_configure

override_dh_auto_build:
	# Make sure we regenerate all the generated *.inc files. Unfortunately, we
	# need two binaries that FTBFS without the *.inc files to start with.
	make build-tools
	make -C source/component clean all
	make -C source/component/images all
	make -C source/component/tipue all
	dh_auto_build

	# Use the help from the binary to create a man page as none is supplied.
	help2man --output=pasdoc.1 --name="documentation tool for Pascal source code" \
		 --no-info bin/pasdoc

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	cd tests && ./run_all_tests.sh
endif
